<html>

<head>
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <link rel="stylesheet" href="/css/bootstrap.css">
    <link rel="stylesheet" href="/css/token.css">
    <script src="/js/jquery.min.js"></script>
    <script src="/js/bootstrap.min.js"></script>

    <script>
        $(document).ready(function () {
           // console.log("Type is:" + <% type %>);
            <% if (type == "prosumer" || type == "consumer") { %>
            updateEnergyCons();
            updateEnergyConsTotal();
            updateTokenConsumption();
            <% } %>

            <% if (type == "prosumer") { %>
            updateEnergyProd();
            updateEnergyProdTotal();
            updateTokenConsumption();
            updateTokenGeneration();
            <% } %>

             <% if (type == "producer") { %>
            getProducerContribution();
            <% } %>
            
            $("#requestCHFButton").click(function(e) {
                e.preventDefault();
                console.log("Requested CHF");
                requestCHF();
     
            });
            updateCurrentCHFBalance();
        });
        function getProducerContribution(){
            $.ajax({
                type: "GET",
                dataType: "json",
                url: "http://localhost:3000/energy/producer",
                timeout: 3000,
                success: function (data) {
                    console.log("producer" + data);
                    if (data != undefined) {
                        var power = (parseFloat(data) * 0.2).toFixed(3);
			console.log("percentage is "+power);
                        $("#production").html(data + " kW ");
                       
                        $(".progress-bar-success").css("height", power * 100 + "%");
                    } else {
                        $("#production").html("-.-- kW");
                        $(".progress-bar-success").css("height", "0%");
                    }
                },
                error: function (parsedjson, textStatus, errorThrown) {
                    console.log("getProducerContribution: " + errorThrown);
                },
                complete: function() {
                    setTimeout(getProducerContribution, 1000);
                }
            });
        }

        function updateEnergyProd() {
            $.ajax({
                type: "GET",
                dataType: "json",
                url: "http://localhost:3000/energy/production",
                timeout: 3000,
                success: function (data) {
                    console.log("Prod-Data" + data);
                    if (data != undefined && data.power != undefined) {
                        var power = (parseFloat(data.power) / 1000).toFixed(3);
                        $("#production").html(power + " kW ");
                       
                        $(".progress-bar-success").css("height", power * 100 + "%");
                    } else {
                        $("#production").html("-.-- kW");
                        $(".progress-bar-success").css("height", "0%");
                    }
                },
                error: function (parsedjson, textStatus, errorThrown) {
                    console.log("updateEnergyProd: " + errorThrown);
                },
                complete: function() {
                    setTimeout(updateEnergyProd, 1000);
                }
            });
        }

        function requestCHF(){
            $('#requestCHFButton').prop('disabled', true);
            $.ajax({
                type: "GET",
                dataType: "json",
                url: "http://localhost:3000/blockchain/requestchf",
                timeout: 100000,
                success: function (data) {
                    console.log("TEST");
                    console.log("Got requested CHF" + data);
                    updateChfBalance(data);
                    $('#requestCHFButton').prop('disabled', false);
                },
                error: function (parsedjson, textStatus, errorThrown) {
                    console.log("error requestCHF: " + errorThrown);
                }
            });
        }

        function updateEnergyProdTotal() {
            $.ajax({
                type: "GET",
                dataType: "json",
                url: "http://localhost:3000/energy/total/production",
                timeout: 3000,
                success: function (data) {
                    if (data != undefined && data.prod_total != undefined) {
                        $("#prod_total").html(data.prod_total + " kWh ");
                    } else {
                        $("#prod_total").html("-.-- kWh ");
                    }
                },
                error: function (parsedjson, textStatus, errorThrown) {
                    console.log("updateEnergyProdTotal: " + errorThrown);
                },
                complete: function() {
                    setTimeout(updateEnergyProdTotal, 1000);
                }
            });
        }

        function updateEnergyCons() {
            $.ajax({
                type: "GET",
                dataType: "json",
                url: "http://localhost:3000/energy/consumption",
                timeout: 3000,
                success: function (data) {
                    console.log(data);
                    if (data != undefined && data.power != undefined) {
                        var power = (parseFloat(data.power) / 1000).toFixed(3);
                        $("#consumption").html(power + " kW ");
                        $(".progress-bar-danger").css("height", power * 100 + "%");
                    } else {
                        $("#consumption").html("-.-- kW");
                        $(".progress-bar-danger").css("height", "0%");
                    }
                },
                error: function (parsedjson, textStatus, errorThrown) {
                    console.log("updateEnergyCons: " + errorThrown);
                },
                complete: function () {
                    setTimeout(updateEnergyCons, 1000);
                }
            });
        }

        function updateEnergyConsTotal() {
            $.ajax({
                type: "GET",
                dataType: "json",
                url: "http://localhost:3000/energy/total/consumption",
                timeout: 3000,
                success: function (data) {
                    console.log(data);
                    if (data != undefined && data.cons_total != undefined) {
                        $("#cons_total").html(data.cons_total + " kWh ");
                        
                    } else {
                        $("#cons_total").html("-.-- kWh ");
                    }
                },
                error: function (parsedjson, textStatus, errorThrown) {
                    console.log("updateEnergyConsTotal: " + updateEnergyConsTotal);
                },
                complete: function () {
                    setTimeout(updateEnergyConsTotal, 1000);
                }
            });
        }

        function updateTokenConsumption() {
            $.ajax({
                type: "GET",
                dataType: "json",
                url: "http://localhost:3000/energy/token/consumption",
                timeout: 3000,
                success: function (data) {
                    if (data != undefined && data != undefined) {
                        var percentageConsumption =  parseFloat((data / 10).toFixed(3));
                        console.log("Consumption is "+ percentageConsumption);
                        loopit("consumption", percentageConsumption);
                        
                    }
                },
                error: function (parsedjson, textStatus, errorThrown) {
                    console.log("couldnt check token production error-code: " + errorThrown);
                },
                complete: function () {
                    setTimeout(updateTokenConsumption, 1000);
                }
            });
        }
        function updateTokenGeneration() {
            $.ajax({
                type: "GET",
                dataType: "json",
                url: "http://localhost:3000/energy/token/production",
                timeout: 3000,
                success: function (data) {
                    if (data != undefined && data != undefined) {
                        var percentageGeneration =  parseInt(data / 10);
                        console.log("Generation is "+ percentageGeneration);
                        loopit("generation", percentageGeneration);
                        
                    }
                },
                error: function (parsedjson, textStatus, errorThrown) {
                    console.log("couldnt check token production error-code: " + errorThrown);
                },
                complete: function () {
                    setTimeout(updateTokenGeneration, 1000);
                }
            });
        }

        // -------------------


        function updateCurrentCHFBalance() {
            
            $.ajax({
                type: "GET",
                dataType: "json",
                url: "http://localhost:3000/blockchain/balance/chftoken",
                timeout: 100000,
                success: function (data) {
                    console.log("REST Call");
                    console.log(data);
                    if (data != null) {
                        updateChfBalance(data);
                    }
                    

                },
                error: function (parsedjson, textStatus, errorThrown) {
                    console.log("updateCurrentCHFBalance: " + errorThrown);
                    console.log(parsedjson);
                    console.log(errorThrown);
                },
                complete: function () {
                    setTimeout(updateCurrentCHFBalance, 1000);
                }
            });
        }
        
        function updateChfBalance(balance) {
            console.log("Current Balance is " + balance);
            $("#balance").html(parseFloat(balance).toFixed(2) + " CHF");
        }

       var i = 0 , prec;

    function changeTokenPercentage(mode, degree, backgroundcolor){
        if(mode=="consumption"){
            var activeBorder = $("#active_consumption");
            activeBorder.css('background-image','linear-gradient(' + (degree) + 'deg, transparent 50%, ' + backgroundcolor +' 50%),linear-gradient(90deg, #d9534f 50%, transparent 50%)');
        }
        if(mode=="generation"){
            var activeBorder = $("#active_generation");
            activeBorder.css('background-image','linear-gradient(' + (degree) + 'deg, transparent 50%, '+ backgroundcolor+' 50%),linear-gradient(90deg, #5cb85c 50%, transparent 50%)');
        }

    }

    function loopit(mode, i){
        console.log("mode is "+ mode);
 
        degree = 360*(i/100)
        $("#prec_" + mode).html(Math.round(i)+"%");
        var colorcode;
        if (degree<=180){
            if(mode == "generation"){
                changeTokenPercentage(mode, 90+degree, "#5cb85c");
            }else{
                changeTokenPercentage(mode, 90+degree, "#d9534f");
            }
            
        }
        else{
            if(mode == "generation"){
                changeTokenPercentage(mode, degree-90, "#3e753f");
            }else{
                changeTokenPercentage(mode, degree-90, "#a74544");
                
            }
            
        }
        
        
    }
    </script>
</head>

<body>
    <% include ../partials/header %>

    <!--main -->
    <div class="container-fluid">
        <div class="row">
            <div class="col-xs-5">
                

                <% if (type == "prosumer" || type == "producer" ) { %>
                <div class="panel panel-success bs-panel">
                    <div style="padding: 5 10 0 10" class="panel-heading">
                        <h4>Production</h4>
                    </div>
                    <div class="panel-body">
                        <div class="row">
                            <div class="col-xs-5">
                                <span class="pull-left">
                                    <h4>Power</h4>
                                </span>
                            </div>
                            <div class="col-xs-5">
                                <span class="pull-right">
                                    <h4>
                                        <span id="production"></span>
                                    </h4>
                                </span>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-5">
                                <span style="width: 200px" class="pull-left">
                                    <h4>Energy</h4>
                                </span>
                            </div>
                            <div class="col-xs-5">
                                <span class="pull-right">
                                    <h4>
                                        <span id="prod_total"></span>
                                    </h4>
                                </span>
                            </div>
                        </div>
                    </div>
                </div>
                <% } %>

                <% if (type == "prosumer" || type == "consumer") { %>
                    <div class="panel panel-danger bs-panel">
                        <div style="padding: 5 10 0 10" class="panel-heading">
                            <h4>Consumption</h4>
                        </div>
                        <div class="panel-body">
                            <div class="row">
                                <div class="col-xs-5">
                                    <span class="pull-left">
                                        <h4>Power</h4>
                                    </span>
                                </div>
                                <div class="col-xs-5">
                                    <span class="pull-right">
                                        <h4>
                                            <span id="consumption"></span>
                                        </h4>
                                    </span>
                                </div>
                            </div>
                            <div class="row">
                                <div class="col-xs-5">
                                    <span style="width: 200px" class="pull-left">
                                        <h4>Energy </h4>
                                    </span>
                                </div>
                                <div class="col-xs-5">
                                    <span class="pull-right">
                                        <h4>
                                            <span id="cons_total"></span>
                                        </h4>
                                    </span>
                                </div>
                            </div>
                        </div>
                    </div>
                    <% } %>

            </div>

            <div class="col-xs-2">
                <div class="progress-container">
                   

                    <% if (type == "prosumer" || type == "producer" ) { %>
                    <div class="progress progress-bar-vertical">
                        <div class="progress-bar progress-bar-success progress-bar-striped active" role="progressbar" style="height: 100%; background-color:#3e753f">
                        </div>
                    </div>
                    <% } %>

                    <% if (type == "prosumer" || type == "consumer" ) { %>
                        <div class="progress progress-bar-vertical">
                            <div class="progress-bar progress-bar-danger progress-bar-striped active" role="progressbar" style="height: 100%; background-color:#a74544">
                            </div>
                        </div>
                        <% } %>
                </div>
            </div>

            <div class="col-xs-5 text-center">
                <div class="panel panel-default bs-panel">
                    <div style="padding: 5 10 0 10" class="panel-heading">
                        <h4>SunnyToken</h4>
                    </div>
                    <div class="panel-body">
                        <div class="row">
                            
                            <div class="col-xs-6 pagination-centered" <% if (type == "consumer") { %>style="visibility: hidden"<% } %> >
                                <div class="container">
                                    <div id="active_generation" class="active-border generation">
                                        <div id="circle" class="circle generation_background">
                                            <h4>
                                                <span class="prec" id="prec_generation">0%</span>
                                            </h4>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <div class="col-xs-6 pagination-centered" <% if (type == "producer") { %>style="visibility: hidden"<% } %> >
                                <div class="container">
                                    <div id="active_consumption" class="active-border consumption">
                                        <div id="circle-consumption" class="circle consumption_background">
                                            <h4>
                                                <span class="prec" id="prec_consumption">0%</span>
                                            </h4>
                                        </div>
                                    </div>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            
                            <div class="col-xs-6 text-center" <% if (type == "consumer") { %>style="visibility: hidden"<% } %> >
                                 Token Generation
                            </div>
                            <div class="col-xs-6 text-center" <% if (type == "producer") { %>style="visibility: hidden"<% } %> >            
                                Token Usage
                            </div>
                        </div>
                    </div>
                    
                </div>
                <div class="cols-xs-12 text-center">

                    <span>
                        <h3>Balance</h3>
                    </span>
                    <span>
                        <h4><span id="balance">0.00 CHF</span></h4>
                    </span>
                </div>
                <% if (type != "producer") { %>
                <div class="text-center">
                    <button type="button" id="requestCHFButton" class="btn btn-primary">Load Balance...</button>
                </div>
                <% } %>
            </div>
        </div>
    </div>
</body>

</html>
